/***********************************************************
        	      (C) Copyright 1993
		Curtin University of Technology
		    Perth Western Australia



 This software is provided as is without any warranty express
 or implied.  Curtin University make no representation as to its
 suitability for any purpose whatsoever.

 Permission to use, modify or copy this software and its
 documentation is hereby granted to the source license holder.
 It is an express condition of such permission that the user
 accepts all responsibility for the use of the software and
 further that:

 1.    this notice appears in any copies of the software and the
       supporting documentation; and

 2.    the name of Curtin University not be used in any
       advertising or publicity pertaining to the software nor
       used to endorse or promote any product derived from this
       software without prior specific written permission.

 3.    the software in source form may not be given to any
       party other than those listed on the source license.

******************************************************************/
static char sccsid[] = "@(#)classnames.c	1.3	6/10/93";

/*
 * classnames.c : Map class names to classes. This code is totally
 *	self-contained and so can be used for other projects. A smaller
 *	executable might result from only including the classes an
 *	application needs.
 *
 * George Ferguson, ferguson@cs.rochester.edu, 4 Sep 1991.
 *
 */
#include "xincludes.h"
#include "EzMenu/EzMenu.h"

/* functions defined here */
WidgetClass classNameToWidgetClass ();

static struct tableRec {
    char   *name;
    WidgetClass *class;
    Boolean isShell;
}       table[] = {
    { "Command",		&commandWidgetClass,		False },
    { "Grip",			&gripWidgetClass,		False },
    { "Label",			&labelWidgetClass,		False },
    { "List",			&listWidgetClass,		False },
    { "Scrollbar",		&scrollbarWidgetClass,		False },
    { "StripChart",		&stripChartWidgetClass,		False },
    { "Toggle",			&toggleWidgetClass,		False },
    { "SimpleMenu",		&simpleMenuWidgetClass,		True },
    { "SmeBSB",			&smeBSBObjectClass,		False },
    { "SmeLine",		&smeLineObjectClass,		False },
    { "MenuButton",		&menuButtonWidgetClass,		False },
    { "AsciiText",		&asciiTextWidgetClass,		False },
    { "Box",			&boxWidgetClass,		False },
    { "Dialog",			&dialogWidgetClass,		False },
    { "Form",			&formWidgetClass,		False },
    { "Paned",			&panedWidgetClass,		False },
    { "Viewport",		&viewportWidgetClass,		False },
    { "Shell",			&shellWidgetClass,		True },
    { "OverrideShell",		&overrideShellWidgetClass,	True },
    { "WMShell",		&wmShellWidgetClass,		True },
    { "TransientShell",		&transientShellWidgetClass,	True },
    { "TopLevelShell",		&topLevelShellWidgetClass,	True },
    { "ApplicationShell",	&applicationShellWidgetClass,	True },
    { "EzMenu",			&ezMenuWidgetClass,		True },
    { "Core",			&widgetClass,			False },
    { "Simple",			&simpleWidgetClass,		False },
/* flatmap release - no file stuff */
#if 0
    { "xfwfFileSelector",	&xfwfFileSelectorWidgetClass,	False },
#endif
};

/*
 * classNameToWidgetClass : Returns the WidgetClass with the given "name".
 *	In addition, sets the isShell flag to True or False depending on
 *	whether the class is a Shell class or not.
 *	Return NULL if the name is not the name of any WidgetClass.
 */
WidgetClass
classNameToWidgetClass (name, isShellp)
char   *name;
Boolean *isShellp;
{
    int     i;

    for (i = 0; i < XtNumber (table); i++)
	if (strcmp (name, table[i].name) == 0) {
	    *isShellp = table[i].isShell;
	    return (*(table[i].class));
	}
    return ((WidgetClass) NULL);
}
